> This page is for Afterpay Online Developer, version Main (default).
> For other versions, use one of these documentation indexes:
> - Main (default): https://developers.afterpay.com/afterpay-online-developer/main/llms.txt
> - v1: https://developers.afterpay.com/afterpay-online-developer/v-1/llms.txt
> - Chinese: https://developers.afterpay.com/afterpay-online-developer/chinese/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.afterpay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.afterpay.com/_mcp/server.

# Create Refund

POST https://global-api-sandbox.afterpay.com/v2/payments/{orderId}/refund
Content-Type: application/json

This endpoint performs a full or partial refund. The refund operation is idempotent if a unique `requestId` and `merchantReference` are provided.

If using the [Deferred Payment Flow](../docs/API-DEVELOPMENT/2b.-Auth-and-Capture.md), please be aware that only captured funds can be refunded. Don't create refunds after 120 days from the date of purchase.

**Connection Timeouts**
| Timeout | Time (Seconds) |
|---------|----------------|
| Open    | 10             |
| Read    | 70             |


Reference: https://developers.afterpay.com/afterpay-online-developer/api-reference/reference/payments/create-refund

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Servers

- `https://global-api-sandbox.afterpay.com` (Sandbox, default)
- `https://global-api.afterpay.com` (Production)

## Request

### Path parameters

- `orderId` (string, required) — The unique Afterpay Order ID to apply the refund to.

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects a CreateRefund.

- `requestId` (string, optional) — Unique ID required for safe retries. Max length 64 (varchar).
- `amount` (Money, optional) — Object containing amount and currency. Where a Money object is included in an API request, it will be validated according to the specification above. Invalid Money objects will trigger a **422 Unprocessable Entity response**. The following is a list of common examples: | Example | errorCode | message | | ------------------------------------------------------------------------------- | ---------------------- | ------------------------------------------------------------------------- | | `amount` is omitted or null | invalid\_object | \{Money object}.amount Amount field required | | `amount` has more than 2 decimal places | invalid\_object amount | must be a valid ISO 4217 format value | | `amount` includes a thousands separator comma, for example: "1,000" | invalid\_amount | Amount must be a valid ISO 4217 format value | | `amount` is not a decimal number, for example: "FREE", "\$2" or an empty string | invalid\_object | \{Money object}.amount Amount field must be a valid ISO 4217 format value | | `currency` is omitted or null | invalid\_object | \{Money object}.currency Currency field required | | `currency` is not a valid currency code, not all uppercase or an empty string | invalid\_object | \{Money object}.currency Currency not supported for this merchant | | `currency` is supported by Afterpay, but not valid for the Merchant account | unsupported\_currency | An error occurred |
- `merchantReference` (string, optional) — The merchant’s internal refund id/reference. This must be included along with the `requestId` to utilise idempotency. Max length 85 (varchar).
- `refundMerchantReference` (string, optional) — A unique reference for the individual refund event. Max length 128 (varchar).

## Response

### 201

Returns a Refund object in response. All request parameters will be echoed in the response. In addition, the response includes the following: | Attribute | Type | Description | | --- | --- | --- | | `refundId` | string | The unique, permanent, Afterpay-generated Refund ID. | | `refundedAt` | string | The UTC timestamp of when the refund was completed, in [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) format. |

- `amount` (Money, optional) — Object containing amount and currency. Where a Money object is included in an API request, it will be validated according to the specification above. Invalid Money objects will trigger a **422 Unprocessable Entity response**. The following is a list of common examples: | Example | errorCode | message | | ------------------------------------------------------------------------------- | ---------------------- | ------------------------------------------------------------------------- | | `amount` is omitted or null | invalid\_object | \{Money object}.amount Amount field required | | `amount` has more than 2 decimal places | invalid\_object amount | must be a valid ISO 4217 format value | | `amount` includes a thousands separator comma, for example: "1,000" | invalid\_amount | Amount must be a valid ISO 4217 format value | | `amount` is not a decimal number, for example: "FREE", "\$2" or an empty string | invalid\_object | \{Money object}.amount Amount field must be a valid ISO 4217 format value | | `currency` is omitted or null | invalid\_object | \{Money object}.currency Currency field required | | `currency` is not a valid currency code, not all uppercase or an empty string | invalid\_object | \{Money object}.currency Currency not supported for this merchant | | `currency` is supported by Afterpay, but not valid for the Merchant account | unsupported\_currency | An error occurred |
- `merchantReference` (string, optional) — The merchant’s internal refund id/reference. This must be included along with the `requestId` to utilise idempotency. Max length 85 (varchar).
- `refundId` (string, optional) — The unique, permanent, Afterpay-generated Refund ID.
- `refundMerchantReference` (string, optional) — A unique reference for the individual refund event. Max length 128 (varchar).
- `refundedAt` (string, optional)
- `requestId` (string, optional) — Unique ID required for safe retries. Max length 64 (varchar).

## Errors

### 412 Precondition Failed Error

The `orderId` is invalid, does not exist, or is not eligible for a refund. For example, the order was declined. Error code `precondition_failed`.

- `any`

### 422 Unprocessable Entity Error

| errorCode | Description | | --- | --- | | invalid_object | The `refundMerchantReference` exceeded 128 characters. | | invalid_amount | The `amount` requested exceeded the amount available. | | invalid_object | The currency of the refund does not match the currency of the order (and the Merchant account). | | refund_timelimit_exceeded | The refund exceeds the time limit of 120 days |

- `any`

## Types

### Money

Object containing amount and currency. Where a Money object is included in an API request, it will be validated according to the specification above. Invalid Money objects will trigger a **422 Unprocessable Entity response**. The following is a list of common examples: | Example | errorCode | message | | ------------------------------------------------------------------------------- | ---------------------- | ------------------------------------------------------------------------- | | `amount` is omitted or null | invalid\_object | \{Money object}.amount Amount field required | | `amount` has more than 2 decimal places | invalid\_object amount | must be a valid ISO 4217 format value | | `amount` includes a thousands separator comma, for example: "1,000" | invalid\_amount | Amount must be a valid ISO 4217 format value | | `amount` is not a decimal number, for example: "FREE", "\$2" or an empty string | invalid\_object | \{Money object}.amount Amount field must be a valid ISO 4217 format value | | `currency` is omitted or null | invalid\_object | \{Money object}.currency Currency field required | | `currency` is not a valid currency code, not all uppercase or an empty string | invalid\_object | \{Money object}.currency Currency not supported for this merchant | | `currency` is supported by Afterpay, but not valid for the Merchant account | unsupported\_currency | An error occurred |

- `amount` (string, required) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (enum, required) — The currency in ISO 4217 format. The value provided must correspond to the currency of the merchant account making the request.
  - Allowed values: `AUD`, `NZD`, `USD`, `CAD`, `GBP`

## Examples

**Request**

```json
{
  "requestId": "49efce77-4bf2-4e41-86e8-c2b92f493c2a",
  "amount": {
    "amount": "10.00",
    "currency": "AUD"
  },
  "merchantReference": "merchantRefundId-1234",
  "refundMerchantReference": "merchantRefundId-1234"
}
```

**Response**

```json
{
  "amount": {
    "amount": "10.00",
    "currency": "AUD"
  },
  "merchantReference": "merchantRefundId-1234",
  "refundId": "67890123",
  "refundMerchantReference": "merchantRefundId-1234",
  "refundedAt": "2023-01-01T00:00:00.000Z",
  "requestId": "49efce77-4bf2-4e41-86e8-c2b92f493c2a"
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund"

payload = {
    "requestId": "49efce77-4bf2-4e41-86e8-c2b92f493c2a",
    "amount": {
        "amount": "10.00",
        "currency": "AUD"
    },
    "merchantReference": "merchantRefundId-1234",
    "refundMerchantReference": "merchantRefundId-1234"
}
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"requestId":"49efce77-4bf2-4e41-86e8-c2b92f493c2a","amount":{"amount":"10.00","currency":"AUD"},"merchantReference":"merchantRefundId-1234","refundMerchantReference":"merchantRefundId-1234"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund"

	payload := strings.NewReader("{\n  \"requestId\": \"49efce77-4bf2-4e41-86e8-c2b92f493c2a\",\n  \"amount\": {\n    \"amount\": \"10.00\",\n    \"currency\": \"AUD\"\n  },\n  \"merchantReference\": \"merchantRefundId-1234\",\n  \"refundMerchantReference\": \"merchantRefundId-1234\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"requestId\": \"49efce77-4bf2-4e41-86e8-c2b92f493c2a\",\n  \"amount\": {\n    \"amount\": \"10.00\",\n    \"currency\": \"AUD\"\n  },\n  \"merchantReference\": \"merchantRefundId-1234\",\n  \"refundMerchantReference\": \"merchantRefundId-1234\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"requestId\": \"49efce77-4bf2-4e41-86e8-c2b92f493c2a\",\n  \"amount\": {\n    \"amount\": \"10.00\",\n    \"currency\": \"AUD\"\n  },\n  \"merchantReference\": \"merchantRefundId-1234\",\n  \"refundMerchantReference\": \"merchantRefundId-1234\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund', [
  'body' => '{
  "requestId": "49efce77-4bf2-4e41-86e8-c2b92f493c2a",
  "amount": {
    "amount": "10.00",
    "currency": "AUD"
  },
  "merchantReference": "merchantRefundId-1234",
  "refundMerchantReference": "merchantRefundId-1234"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"requestId\": \"49efce77-4bf2-4e41-86e8-c2b92f493c2a\",\n  \"amount\": {\n    \"amount\": \"10.00\",\n    \"currency\": \"AUD\"\n  },\n  \"merchantReference\": \"merchantRefundId-1234\",\n  \"refundMerchantReference\": \"merchantRefundId-1234\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [
  "requestId": "49efce77-4bf2-4e41-86e8-c2b92f493c2a",
  "amount": [
    "amount": "10.00",
    "currency": "AUD"
  ],
  "merchantReference": "merchantRefundId-1234",
  "refundMerchantReference": "merchantRefundId-1234"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```